/*--------------------------------------------------------------------------*/
/*                                                                          */
/*                                                                          */
/*      ------------         Bit-Bucket Software <no-Inc>                   */
/*      \ 10001101 /         Writers and Distributors of                    */
/*       \ 011110 /          No-Cost<no-tm> Software.                       */
/*        \ 1011 /                                                          */
/*         ------            KopyRong (K) 1987.  ALL RIGHTS REVERSED.       */
/*                                                                          */
/*                                                                          */
/*               This module was written by Vince Perriello                 */
/*                                                                          */
/*                                                                          */
/*                 BinkleyTerm Fidolist processing module                   */
/*                                                                          */
/*                                                                          */
/*   This  software  package is being distributed WITH FULL SOURCE CODE     */
/*   with the  following  conditions:    1)  If  anything awful happens     */
/*   because  you  use    it   (or  don't  use  it),  you  accept  full     */
/*   responsibility;  2) you  don't start making tons of voice calls to     */
/*   the authors to complain or  make  suggestions  about enhancements,     */
/*   useful or otherwise;  3) you  do not reuse this code in commercial     */
/*   products without specific permission to do so  from  the  authors;     */
/*   4) If you find any problems you send  fixes  to  the  authors  for     */
/*   inclusion  in  updates;    5) You find some way  to  express  your     */
/*   appreciation  for  this  method of distribution, either by writing     */
/*   code or  application  notes,  or  just sending along a "Thank You"     */
/*   message.                                                               */
/*                                                                          */
/*   There is  copyrighted  code  in  this product.  We either wrote it     */
/*   ourselves or got  permission  to use it.  Please don't force us to     */
/*   pay a lawyer --  have some respect for our motives and don't abuse     */
/*   this "license".                                                        */
/*                                                                          */
/*                                                                          */
/*--------------------------------------------------------------------------*/

#include <stdio.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <fcntl.h>

#include "com.h"
#include "xfer.h"
#include "keybd.h"

static int      reclength = -1;
static int      nrecs = -1;
extern struct pointers ctl;     /* where all the strings is  */

fidouser (name, zone, net, node, point)
char           *name;
int            *zone;
int            *net;
int            *node;
int            *point;
{
   int             low, high, mid, f, cond, namelen;
   char            midname[80];
   char            last_name_first[80];
   char           *c, *p, *m;
   struct stat     buffer;

   *zone = *net = *node = *point = -1;

   c = midname;                 /* Start of temp name buff   */
   p = name;                    /* Point to start of name    */
   m = NULL;                    /* Init pointer to space     */

   while (*c = *p++)            /* Go entire length of name  */
      {
      if (*c == ' ')            /* Look for space            */
         m = c;                 /* Save location             */
      c++;
      }

   if (m != NULL)               /* If we have a pointer,     */
      {
      *m++ = '\0';              /* Terminate the first half  */
      strcpy (last_name_first, m);      /* Now copy the last name    */
      strcat (last_name_first, ", ");   /* Insert a comma and space  */
      strcat (last_name_first, midname);        /* Finally copy first half   */
      }
   else
      strcpy (last_name_first, midname);        /* Use whole name otherwise  */

   fancy_str (last_name_first); /* Get caps in where needed  */
   namelen = strlen (last_name_first);  /* Calc length now           */

   midname[0] = '\0';           /* "null-terminated string"  */
   strcpy (midname, ctl.net_info);      /* take nodelist path        */
   strcat (midname, "FIDOUSER.LST");    /* add in the file name      */
   if ((f = open (midname, O_RDONLY | O_BINARY)) == -1)
      {
      reclength = -1;           /* Reset all on open failure */
      return;
      }

   /* Find out if we have done this before */
   if (reclength == -1)
      {
      /* If not, then determine file size and record length */

      fstat (f, &buffer);       /* Get file stats in buffer  */
      read (f, midname, 80);    /* Read 1 record             */
      reclength = (strchr (midname, '\n') - (int) midname) + 1; /* FindEnd */
      nrecs = buffer.st_size / reclength;       /* Now get num of records    */
      }

   /* Binary search algorithm */
   low = 0;
   high = nrecs - 1;
   while (low <= high)
      {
      mid = low + (high - low) / 2;
      lseek (f, (long) ((long) mid * (long) reclength), SEEK_SET);
      read (f, midname, reclength);
      if ((cond = strnicmp (last_name_first, midname, namelen)) < 0)
         high = mid - 1;
      else
         {
         if (cond > 0)
            low = mid + 1;
         else
            {
            /* Return the address information */
            close (f);
            /* The offset of 40 is just a number that should work properly */
            if (sscanf (&midname[40], "%d:%d/%d.%d", zone, net, node, point) != 4)
               {
               *zone = *net = *node = -1;
               *point = 0;
               if (sscanf (&midname[40], "%d:%d/%d", zone, net, node) != 3)
                  {
                  *net = *node = *point = -1;
                  /* Really should set what our zone is */
                  *zone = 1;
                  if (sscanf (&midname[40], "%d/%d.%d", net, node, point) != 3)
                     {
                     *net = *node = -1;
                     /* Really should set what our zone is */
                     *zone = 1;
                     *point = 0;
                     if (sscanf (&midname[40], "%d/%d", net, node) != 2)
                        {
                        *zone = *net = *node = *point = -1;
                        }
                     }
                  }
               }
            return;
            }
         }
      }
   *zone = *net = *node = *point = -1;
   close (f);
}
