/*--------------------------------------------------------------------------*/
/*               The Opus Computer-Based Conversation System                */
/*       (c) Copyright 1987, Wynn Wagner III, All Rights Reserved           */
/*                                                                          */
/*                   YOOHOO is a trademark of Wynn Wagner III               */
/*                                                                          */
/*                            YOOHOO-YOOHOO/2U2 is                          */
/*           Copyright 1987, Wynn Wagner III, All Rights Reserved           */
/*                                                                          */
/*                                                                          */
/*                      BinkleyTerm Password Processor                      */
/*                                                                          */
/*                                                                          */
/*  This module is a very simple FOSSIL-based terminal emulator. It is      */
/*  provided for your information only.  You will find routines that need   */
/*  to be coded and identifiers to be resolved. It has been previously      */
/*  known as "OpusLink" and "OConnect". The use of the name "BinkleyTerm"   */
/*  does not preclude the possibility that another "OpusLink" or "OConnect" */
/*  could be released.                                                      */
/*                                                                          */
/*  There is absolutely no guarantee that anything here will work.  If you  */
/*  break this routine, you own both pieces.                                */
/*                                                                          */
/*  USAGE:  You may use this material in any program with no obligation     */
/*          as long as there is no charge for your program.  For more       */
/*          information about commercial use, contact the "OPUSinfo HERE"   */
/*          BBS (124/111).                                                  */
/*                                                                          */
/*                                                                          */
/*--------------------------------------------------------------------------*/

#include <signal.h>
#include <ctype.h>
#include <conio.h>

#define WAZOO_SECTION
#include "zmodem.h"

#include "com.h"

static char    *snitty_message = "Sorry, Charlie.";

/*--------------------------------------------------------------------------*/
/* N PASSWORD                                                               */
/*--------------------------------------------------------------------------*/
n_password (theirs, ours)
char           *theirs;
char           *ours;
{
   if (theirs[0])
      {
      fancy_str (theirs);
      fancy_str (ours);

      if (strnicmp (theirs, ours, 6))
         {
         register int    i;

         status_line ("!Pwd Err (%d/%d): %s/%s",
                      remote_net,
                      remote_node,
                      theirs,
                      ours
            );

         SENDCHARS (snitty_message, strlen (snitty_message), 0);

         while (!OUT_EMPTY ())
            time_release ();

         return 1;
         }

      status_line ("*Password-protected session");
      strncpy (theirs, ours, 8);
      theirs[6] = '\0';
      }

   return 0;

}


/*--------------------------------------------------------------------------*/
/* N GET PASSWORD                                                           */
/* Find the nodelist entry for this system and point remote_password at     */
/* its password if any                                                      */
/*--------------------------------------------------------------------------*/
n_getpassword (zone, net, node)
int             zone, net, node;
{
   extern char    *remote_password;
   extern struct _newnode newnodedes;   /* desc. of node            */

   remote_password = NULL;      /* Default to no password   */

   if ((net != newnodedes.NetNumber)    /* If we don't have it yet  */
       || (node != newnodedes.NodeNumber))      /* we'll have to get it ... */
      {
      if (!nodefind (zone, net, node))  /* find the node in the list */
         {
         remote_password = NULL;
         return (0);            /* return failure if can't  */
         }
      }
   if (newnodedes.Password[0] != '\0')  /* If anything there,       */
      remote_password = &newnodedes.Password[0];        /* Point at it            */
   return (1);                  /* Successful attempt       */
}
